%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               Table of Contents                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   1.  Initialisation
%       1.1 Packages
%       1.2 Colours
%       1.3 Title Page
%       1.4 Header and Footer Page Styles
%       1.5 Subsubsubsection (Custom)
%       1.6 Other

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               1. Initialisation                %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%================================================%
%                  1.1 Packages                  %
%================================================%

% Formatting
\usepackage{booktabs}
\usepackage{fancyhdr}
\usepackage{geometry}
\usepackage[hidelinks]{hyperref}
\usepackage{lastpage}
\usepackage{adjustbox} 
\usepackage{titling} % Titlepage
\usepackage{datetime} % Date on titlepage
\newdateformat{myformat}{\THEDAY{. }\monthname[\THEMONTH] \THEYEAR}

% Typography
\usepackage[ngerman]{babel}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage{microtype}
\usepackage{titlesec}
\usepackage[font=small,justification=raggedright,singlelinecheck=false,skip=5pt]{caption}
% \setlength{\captionmargin}{18pt} % Indents captions 18pt to the right
\usepackage{csquotes}
\usepackage{enumitem}
\usepackage{lmodern}

% Definition of \paragraph starting new line after heading
\titleformat{\paragraph}
    {\normalfont\normalsize\bfseries}{\theparagraph}{1em}{}
\titlespacing*{\paragraph}{\parindent}{3.25ex plus 1ex minus .2ex}{2ex plus .1ex} % Second {} to change vertical spacing after paragraph

% Definition of \subparagraph starting new line after heading
\titleformat{\subparagraph}
    {\normalfont\normalsize\bfseries}{\thesubparagraph}{1em}{}
\titlespacing*{\subparagraph}{\parindent}{3.25ex plus 1ex minus .2ex}{2ex plus .1ex} % Second {} to change vertical spacing after subparagraph

% Mathematics
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{cancel} % To strike through maths terms
\usepackage{siunitx} % SI-Units
\usepackage{textcomp}
\usepackage{extarrows}
\usepackage{wasysym}
\usepackage[nooldvoltagedirection,european,siunitx]{circuitikz} % Circuits

% Graphics and Plots
\usepackage{wrapfig}
\usepackage{graphicx}
\graphicspath{%
  % Max path length is 82 characters starting from Passerelle_KME\LaTeX\
  {./Images/}
  {../Images/}
  {../../Images/}
}
\usepackage{epstopdf}
\epstopdfsetup{update,suffix=-conv} % Only regenerate pdf files when eps file is newer; Changes suffix of converted images from default "-eps-converted-to" to "-conv"
\usepackage{tikz}
\pgfdeclarelayer{bg}    % declare background layer
\pgfsetlayers{bg,main}  % set the order of the layers (main is the standard layer)
   
\usetikzlibrary{    shapes,
                    arrows,            % Pfeilform
                    arrows.meta, 
                    chains, 
                    external,          % Externalizing graphics
                    positioning,        % Node distance
                    math,
                    decorations.markings,
                    fadings
                }  
\usepackage{pgfplots}
\usepgfplotslibrary{units}
\pgfplotsset{
   compat = 1.7 ,
   yticklabel style = {/pgf/number format/.cd,fixed,fixed zerofill,precision=4} ,
   samples = 100 ,
   scaled ticks = false 
}
% Plot styles
\pgfplotsset{orangemarker/.style={color=orange,only marks,mark=*, mark options={scale=0.5}}}
\addtolength{\jot}{1em} % Adds 1em of spacing to all align environments
\def\arraystretch{1.25} % Stretches tables by amount specified in percent
\usepackage{float}
\usepackage{xcolor}

%================================================%
%                   1.2 Colours                  %
%================================================%

\definecolor{MyRed}{HTML}{D14B4A}
\definecolor{MyOrange}{HTML}{D3A147}
\definecolor{MyYellow}{HTML}{CECA48}
\definecolor{MyGreen}{HTML}{7EC34F}
\definecolor{MyLightBlue}{HTML}{459ED7}
\definecolor{MyDarkBlue}{HTML}{506CAB}
\definecolor{MyViolet}{HTML}{7E56A3}
\definecolor{MyBrown}{HTML}{4F3F2D}
\definecolor{MyLightGrey}{HTML}{BCBCBC}
\definecolor{MyGrey}{HTML}{969696}
\definecolor{MyBlack}{HTML}{1B1B1B}

%================================================%
%                 1.3 Title Page                 %
%================================================%

\author{Alexander Rolley}

%================================================%
%        1.4 Header and Footer Page Styles       %
%================================================%

% https://tex.stackexchange.com/questions/222370/how-can-i-customize-and-use-the-leftmark-and-rightmark-commands-with-custom-fa
\pagestyle{fancy} % This must be here, because defaults are set and renewcommand for section marks will work.

% Removes number next to section in header
\renewcommand{\sectionmark}[1]{\markright{#1}}
\renewcommand{\subsectionmark}[1]{}

% Footer
\fancyhf{}
\cfoot{\today}
\rfoot{Seite \thepage \ von \pageref{LastPage}}
\renewcommand{\headrulewidth}{1pt} 

\fancypagestyle{NormalStyle}{% Footer must come before header
  % Footer
  \lfoot{Alexander Rolley}
}

\fancypagestyle{CreditStefanStyle}{% Footer must come before header
  % Footer
  \lfoot{S. Gloor, A. Rolley}
}

% Header
\chead{\nouppercase{\rightmark}}
\renewcommand{\footrulewidth}{1pt}
\geometry{bottom=30mm} % MUST be used outside of \fancypagestyle{}{}, otherwise it won't compile (Error: can only be used in preamble)

%================================================%
%          1.5 Subsubsubsection (Custom)         %
%================================================%

% Adds a new level after \subsubsection{}: \subsubsubsection{}
% \paragraph{} and \subparagraph{} are redefined to be one/tow levels below \subsubsubsection{} respectively
% https://tex.stackexchange.com/questions/60209/how-to-add-an-extra-level-of-sections-with-headings-below-subsubsection

\titleclass{\subsubsubsection}{straight}[\subsection]

\newcounter{subsubsubsection}[subsubsection]
\renewcommand\thesubsubsubsection{\thesubsubsection.\arabic{subsubsubsection}}
% \renewcommand\theparagraph{\thesubsubsubsection.\arabic{paragraph}} % optional; useful if paragraphs are to be numbered

\titleformat{\subsubsubsection}
  {\normalfont\normalsize\bfseries}{\thesubsubsubsection}{1em}{}
\titlespacing*{\subsubsubsection}
{0pt}{3.25ex plus 1ex minus .2ex}{1.5ex plus .2ex}

\makeatletter
\renewcommand\paragraph{\@startsection{paragraph}{5}{\z@}%
  {3.25ex \@plus1ex \@minus.2ex}%
  {1.5ex plus .2ex}% Spacing after
  {\normalfont\normalsize\bfseries}}

\renewcommand\subparagraph{\@startsection{subparagraph}{6}{\parindent}%
  {3.25ex \@plus1ex \@minus .2ex}%
  {1.5ex plus .2ex}% Spacing after
  {\normalfont\normalsize\bfseries}}

\def\toclevel@subsubsubsection{4}
\def\toclevel@paragraph{5}
\def\toclevel@paragraph{6}
\def\l@subsubsubsection{\@dottedtocline{4}{7em}{4em}}
\def\l@paragraph{\@dottedtocline{5}{10em}{5em}}
\def\l@subparagraph{\@dottedtocline{6}{14em}{6em}}
\makeatother

\setcounter{secnumdepth}{4}
\setcounter{tocdepth}{4}

%================================================%
%                   1.6 Other                    %
%================================================%

% Paragraph first line indent
\setlength\parindent{0em}

% Reseting of the equation counter at the beginning of each section and the inclusion of the section number in the equation numbering
\numberwithin{equation}{section}